Merge branch 'rj/test-i18ngrep'
[git] / git-rebase--interactive.sh
1 # This shell script fragment is sourced by git-rebase to implement
2 # its interactive mode.  "git rebase --interactive" makes it easy
3 # to fix up commits in the middle of a series and rearrange commits.
4 #
5 # Copyright (c) 2006 Johannes E. Schindelin
6 #
7 # The original idea comes from Eric W. Biederman, in
8 # https://public-inbox.org/git/m1odwkyuf5.fsf_-_@ebiederm.dsl.xmission.com/
9 #
10 # The file containing rebase commands, comments, and empty lines.
11 # This file is created by "git rebase -i" then edited by the user.  As
12 # the lines are processed, they are removed from the front of this
13 # file and written to the tail of $done.
14 todo="$state_dir"/git-rebase-todo
15
16 # The rebase command lines that have already been processed.  A line
17 # is moved here when it is first handled, before any associated user
18 # actions.
19 done="$state_dir"/done
20
21 # The commit message that is planned to be used for any changes that
22 # need to be committed following a user interaction.
23 msg="$state_dir"/message
24
25 # The file into which is accumulated the suggested commit message for
26 # squash/fixup commands.  When the first of a series of squash/fixups
27 # is seen, the file is created and the commit message from the
28 # previous commit and from the first squash/fixup commit are written
29 # to it.  The commit message for each subsequent squash/fixup commit
30 # is appended to the file as it is processed.
31 #
32 # The first line of the file is of the form
33 #     # This is a combination of $count commits.
34 # where $count is the number of commits whose messages have been
35 # written to the file so far (including the initial "pick" commit).
36 # Each time that a commit message is processed, this line is read and
37 # updated.  It is deleted just before the combined commit is made.
38 squash_msg="$state_dir"/message-squash
39
40 # If the current series of squash/fixups has not yet included a squash
41 # command, then this file exists and holds the commit message of the
42 # original "pick" commit.  (If the series ends without a "squash"
43 # command, then this can be used as the commit message of the combined
44 # commit without opening the editor.)
45 fixup_msg="$state_dir"/message-fixup
46
47 # $rewritten is the name of a directory containing files for each
48 # commit that is reachable by at least one merge base of $head and
49 # $upstream. They are not necessarily rewritten, but their children
50 # might be.  This ensures that commits on merged, but otherwise
51 # unrelated side branches are left alone. (Think "X" in the man page's
52 # example.)
53 rewritten="$state_dir"/rewritten
54
55 dropped="$state_dir"/dropped
56
57 end="$state_dir"/end
58 msgnum="$state_dir"/msgnum
59
60 # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
61 # GIT_AUTHOR_DATE that will be used for the commit that is currently
62 # being rebased.
63 author_script="$state_dir"/author-script
64
65 # When an "edit" rebase command is being processed, the SHA1 of the
66 # commit to be edited is recorded in this file.  When "git rebase
67 # --continue" is executed, if there are any staged changes then they
68 # will be amended to the HEAD commit, but only provided the HEAD
69 # commit is still the commit to be edited.  When any other rebase
70 # command is processed, this file is deleted.
71 amend="$state_dir"/amend
72
73 # For the post-rewrite hook, we make a list of rewritten commits and
74 # their new sha1s.  The rewritten-pending list keeps the sha1s of
75 # commits that have been processed, but not committed yet,
76 # e.g. because they are waiting for a 'squash' command.
77 rewritten_list="$state_dir"/rewritten-list
78 rewritten_pending="$state_dir"/rewritten-pending
79
80 # Work around Git for Windows' Bash whose "read" does not strip CRLF
81 # and leaves CR at the end instead.
82 cr=$(printf "\015")
83
84 strategy_args=${strategy:+--strategy=$strategy}
85 test -n "$strategy_opts" &&
86 eval '
87         for strategy_opt in '"$strategy_opts"'
88         do
89                 strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
90         done
91 '
92
93 GIT_CHERRY_PICK_HELP="$resolvemsg"
94 export GIT_CHERRY_PICK_HELP
95
96 comment_char=$(git config --get core.commentchar 2>/dev/null)
97 case "$comment_char" in
98 '' | auto)
99         comment_char="#"
100         ;;
101 ?)
102         ;;
103 *)
104         comment_char=$(echo "$comment_char" | cut -c1)
105         ;;
106 esac
107
108 warn () {
109         printf '%s\n' "$*" >&2
110 }
111
112 # Output the commit message for the specified commit.
113 commit_message () {
114         git cat-file commit "$1" | sed "1,/^$/d"
115 }
116
117 orig_reflog_action="$GIT_REFLOG_ACTION"
118
119 comment_for_reflog () {
120         case "$orig_reflog_action" in
121         ''|rebase*)
122                 GIT_REFLOG_ACTION="rebase -i ($1)"
123                 export GIT_REFLOG_ACTION
124                 ;;
125         esac
126 }
127
128 last_count=
129 mark_action_done () {
130         sed -e 1q < "$todo" >> "$done"
131         sed -e 1d < "$todo" >> "$todo".new
132         mv -f "$todo".new "$todo"
133         new_count=$(( $(git stripspace --strip-comments <"$done" | wc -l) ))
134         echo $new_count >"$msgnum"
135         total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
136         echo $total >"$end"
137         if test "$last_count" != "$new_count"
138         then
139                 last_count=$new_count
140                 eval_gettext "Rebasing (\$new_count/\$total)"; printf "\r"
141                 test -z "$verbose" || echo
142         fi
143 }
144
145 # Put the last action marked done at the beginning of the todo list
146 # again. If there has not been an action marked done yet, leave the list of
147 # items on the todo list unchanged.
148 reschedule_last_action () {
149         tail -n 1 "$done" | cat - "$todo" >"$todo".new
150         sed -e \$d <"$done" >"$done".new
151         mv -f "$todo".new "$todo"
152         mv -f "$done".new "$done"
153 }
154
155 append_todo_help () {
156         gettext "
157 Commands:
158 p, pick = use commit
159 r, reword = use commit, but edit the commit message
160 e, edit = use commit, but stop for amending
161 s, squash = use commit, but meld into previous commit
162 f, fixup = like \"squash\", but discard this commit's log message
163 x, exec = run command (the rest of the line) using shell
164 d, drop = remove commit
165
166 These lines can be re-ordered; they are executed from top to bottom.
167 " | git stripspace --comment-lines >>"$todo"
168
169         if test $(get_missing_commit_check_level) = error
170         then
171                 gettext "
172 Do not remove any line. Use 'drop' explicitly to remove a commit.
173 " | git stripspace --comment-lines >>"$todo"
174         else
175                 gettext "
176 If you remove a line here THAT COMMIT WILL BE LOST.
177 " | git stripspace --comment-lines >>"$todo"
178         fi
179 }
180
181 make_patch () {
182         sha1_and_parents="$(git rev-list --parents -1 "$1")"
183         case "$sha1_and_parents" in
184         ?*' '?*' '?*)
185                 git diff --cc $sha1_and_parents
186                 ;;
187         ?*' '?*)
188                 git diff-tree -p "$1^!"
189                 ;;
190         *)
191                 echo "Root commit"
192                 ;;
193         esac > "$state_dir"/patch
194         test -f "$msg" ||
195                 commit_message "$1" > "$msg"
196         test -f "$author_script" ||
197                 get_author_ident_from_commit "$1" > "$author_script"
198 }
199
200 die_with_patch () {
201         echo "$1" > "$state_dir"/stopped-sha
202         git update-ref REBASE_HEAD "$1"
203         make_patch "$1"
204         die "$2"
205 }
206
207 exit_with_patch () {
208         echo "$1" > "$state_dir"/stopped-sha
209         git update-ref REBASE_HEAD "$1"
210         make_patch $1
211         git rev-parse --verify HEAD > "$amend"
212         gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
213         warn "$(eval_gettext "\
214 You can amend the commit now, with
215
216         git commit --amend \$gpg_sign_opt_quoted
217
218 Once you are satisfied with your changes, run
219
220         git rebase --continue")"
221         warn
222         exit $2
223 }
224
225 die_abort () {
226         apply_autostash
227         rm -rf "$state_dir"
228         die "$1"
229 }
230
231 has_action () {
232         test -n "$(git stripspace --strip-comments <"$1")"
233 }
234
235 is_empty_commit() {
236         tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null) || {
237                 sha1=$1
238                 die "$(eval_gettext "\$sha1: not a commit that can be picked")"
239         }
240         ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null) ||
241                 ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
242         test "$tree" = "$ptree"
243 }
244
245 is_merge_commit()
246 {
247         git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
248 }
249
250 # Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
251 # GIT_AUTHOR_DATE exported from the current environment.
252 do_with_author () {
253         (
254                 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
255                 "$@"
256         )
257 }
258
259 git_sequence_editor () {
260         if test -z "$GIT_SEQUENCE_EDITOR"
261         then
262                 GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
263                 if [ -z "$GIT_SEQUENCE_EDITOR" ]
264                 then
265                         GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
266                 fi
267         fi
268
269         eval "$GIT_SEQUENCE_EDITOR" '"$@"'
270 }
271
272 pick_one () {
273         ff=--ff
274
275         case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
276         case "$force_rebase" in '') ;; ?*) ff= ;; esac
277         output git rev-parse --verify $sha1 || die "$(eval_gettext "Invalid commit name: \$sha1")"
278
279         if is_empty_commit "$sha1"
280         then
281                 empty_args="--allow-empty"
282         fi
283
284         test -d "$rewritten" &&
285                 pick_one_preserving_merges "$@" && return
286         output eval git cherry-pick $allow_rerere_autoupdate $allow_empty_message \
287                         ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
288                         "$strategy_args" $empty_args $ff "$@"
289
290         # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
291         # previous task so this commit is not lost.
292         ret=$?
293         case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
294         return $ret
295 }
296
297 pick_one_preserving_merges () {
298         fast_forward=t
299         case "$1" in
300         -n)
301                 fast_forward=f
302                 sha1=$2
303                 ;;
304         *)
305                 sha1=$1
306                 ;;
307         esac
308         sha1=$(git rev-parse $sha1)
309
310         if test -f "$state_dir"/current-commit
311         then
312                 if test "$fast_forward" = t
313                 then
314                         while read current_commit
315                         do
316                                 git rev-parse HEAD > "$rewritten"/$current_commit
317                         done <"$state_dir"/current-commit
318                         rm "$state_dir"/current-commit ||
319                                 die "$(gettext "Cannot write current commit's replacement sha1")"
320                 fi
321         fi
322
323         echo $sha1 >> "$state_dir"/current-commit
324
325         # rewrite parents; if none were rewritten, we can fast-forward.
326         new_parents=
327         pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
328         if test "$pend" = " "
329         then
330                 pend=" root"
331         fi
332         while [ "$pend" != "" ]
333         do
334                 p=$(expr "$pend" : ' \([^ ]*\)')
335                 pend="${pend# $p}"
336
337                 if test -f "$rewritten"/$p
338                 then
339                         new_p=$(cat "$rewritten"/$p)
340
341                         # If the todo reordered commits, and our parent is marked for
342                         # rewriting, but hasn't been gotten to yet, assume the user meant to
343                         # drop it on top of the current HEAD
344                         if test -z "$new_p"
345                         then
346                                 new_p=$(git rev-parse HEAD)
347                         fi
348
349                         test $p != $new_p && fast_forward=f
350                         case "$new_parents" in
351                         *$new_p*)
352                                 ;; # do nothing; that parent is already there
353                         *)
354                                 new_parents="$new_parents $new_p"
355                                 ;;
356                         esac
357                 else
358                         if test -f "$dropped"/$p
359                         then
360                                 fast_forward=f
361                                 replacement="$(cat "$dropped"/$p)"
362                                 test -z "$replacement" && replacement=root
363                                 pend=" $replacement$pend"
364                         else
365                                 new_parents="$new_parents $p"
366                         fi
367                 fi
368         done
369         case $fast_forward in
370         t)
371                 output warn "$(eval_gettext "Fast-forward to \$sha1")"
372                 output git reset --hard $sha1 ||
373                         die "$(eval_gettext "Cannot fast-forward to \$sha1")"
374                 ;;
375         f)
376                 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
377
378                 if [ "$1" != "-n" ]
379                 then
380                         # detach HEAD to current parent
381                         output git checkout $first_parent 2> /dev/null ||
382                                 die "$(eval_gettext "Cannot move HEAD to \$first_parent")"
383                 fi
384
385                 case "$new_parents" in
386                 ' '*' '*)
387                         test "a$1" = a-n && die "$(eval_gettext "Refusing to squash a merge: \$sha1")"
388
389                         # redo merge
390                         author_script_content=$(get_author_ident_from_commit $sha1)
391                         eval "$author_script_content"
392                         msg_content="$(commit_message $sha1)"
393                         # No point in merging the first parent, that's HEAD
394                         new_parents=${new_parents# $first_parent}
395                         merge_args="--no-log --no-ff"
396                         if ! do_with_author output eval \
397                                 git merge ${gpg_sign_opt:+$(git rev-parse \
398                                         --sq-quote "$gpg_sign_opt")} \
399                                 $allow_rerere_autoupdate "$merge_args" \
400                                 "$strategy_args" \
401                                 -m "$(git rev-parse --sq-quote "$msg_content")" \
402                                 "$new_parents"
403                         then
404                                 printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
405                                 die_with_patch $sha1 "$(eval_gettext "Error redoing merge \$sha1")"
406                         fi
407                         echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
408                         ;;
409                 *)
410                         output eval git cherry-pick $allow_rerere_autoupdate \
411                                 $allow_empty_message \
412                                 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
413                                 "$strategy_args" "$@" ||
414                                 die_with_patch $sha1 "$(eval_gettext "Could not pick \$sha1")"
415                         ;;
416                 esac
417                 ;;
418         esac
419 }
420
421 this_nth_commit_message () {
422         n=$1
423         eval_gettext "This is the commit message #\${n}:"
424 }
425
426 skip_nth_commit_message () {
427         n=$1
428         eval_gettext "The commit message #\${n} will be skipped:"
429 }
430
431 update_squash_messages () {
432         if test -f "$squash_msg"; then
433                 mv "$squash_msg" "$squash_msg".bak || exit
434                 count=$(($(sed -n \
435                         -e "1s/^$comment_char[^0-9]*\([0-9][0-9]*\).*/\1/p" \
436                         -e "q" < "$squash_msg".bak)+1))
437                 {
438                         printf '%s\n' "$comment_char $(eval_ngettext \
439                                 "This is a combination of \$count commit." \
440                                 "This is a combination of \$count commits." \
441                                 $count)"
442                         sed -e 1d -e '2,/^./{
443                                 /^$/d
444                         }' <"$squash_msg".bak
445                 } >"$squash_msg"
446         else
447                 commit_message HEAD >"$fixup_msg" ||
448                 die "$(eval_gettext "Cannot write \$fixup_msg")"
449                 count=2
450                 {
451                         printf '%s\n' "$comment_char $(gettext "This is a combination of 2 commits.")"
452                         printf '%s\n' "$comment_char $(gettext "This is the 1st commit message:")"
453                         echo
454                         cat "$fixup_msg"
455                 } >"$squash_msg"
456         fi
457         case $1 in
458         squash)
459                 rm -f "$fixup_msg"
460                 echo
461                 printf '%s\n' "$comment_char $(this_nth_commit_message $count)"
462                 echo
463                 commit_message $2
464                 ;;
465         fixup)
466                 echo
467                 printf '%s\n' "$comment_char $(skip_nth_commit_message $count)"
468                 echo
469                 # Change the space after the comment character to TAB:
470                 commit_message $2 | git stripspace --comment-lines | sed -e 's/ /       /'
471                 ;;
472         esac >>"$squash_msg"
473 }
474
475 peek_next_command () {
476         git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
477 }
478
479 # A squash/fixup has failed.  Prepare the long version of the squash
480 # commit message, then die_with_patch.  This code path requires the
481 # user to edit the combined commit message for all commits that have
482 # been squashed/fixedup so far.  So also erase the old squash
483 # messages, effectively causing the combined commit to be used as the
484 # new basis for any further squash/fixups.  Args: sha1 rest
485 die_failed_squash() {
486         sha1=$1
487         rest=$2
488         mv "$squash_msg" "$msg" || exit
489         rm -f "$fixup_msg"
490         cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
491         warn
492         warn "$(eval_gettext "Could not apply \$sha1... \$rest")"
493         die_with_patch $sha1 ""
494 }
495
496 flush_rewritten_pending() {
497         test -s "$rewritten_pending" || return
498         newsha1="$(git rev-parse HEAD^0)"
499         sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
500         rm -f "$rewritten_pending"
501 }
502
503 record_in_rewritten() {
504         oldsha1="$(git rev-parse $1)"
505         echo "$oldsha1" >> "$rewritten_pending"
506
507         case "$(peek_next_command)" in
508         squash|s|fixup|f)
509                 ;;
510         *)
511                 flush_rewritten_pending
512                 ;;
513         esac
514 }
515
516 do_pick () {
517         sha1=$1
518         rest=$2
519         if test "$(git rev-parse HEAD)" = "$squash_onto"
520         then
521                 # Set the correct commit message and author info on the
522                 # sentinel root before cherry-picking the original changes
523                 # without committing (-n).  Finally, update the sentinel again
524                 # to include these changes.  If the cherry-pick results in a
525                 # conflict, this means our behaviour is similar to a standard
526                 # failed cherry-pick during rebase, with a dirty index to
527                 # resolve before manually running git commit --amend then git
528                 # rebase --continue.
529                 git commit --allow-empty --allow-empty-message --amend \
530                            --no-post-rewrite -n -q -C $sha1 &&
531                         pick_one -n $sha1 &&
532                         git commit --allow-empty --allow-empty-message \
533                                    --amend --no-post-rewrite -n -q -C $sha1 \
534                                    ${gpg_sign_opt:+"$gpg_sign_opt"} ||
535                                    die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
536         else
537                 pick_one $sha1 ||
538                         die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
539         fi
540 }
541
542 do_next () {
543         rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
544         read -r command sha1 rest < "$todo"
545         case "$command" in
546         "$comment_char"*|''|noop|drop|d)
547                 mark_action_done
548                 ;;
549         "$cr")
550                 # Work around CR left by "read" (e.g. with Git for Windows' Bash).
551                 mark_action_done
552                 ;;
553         pick|p)
554                 comment_for_reflog pick
555
556                 mark_action_done
557                 do_pick $sha1 "$rest"
558                 record_in_rewritten $sha1
559                 ;;
560         reword|r)
561                 comment_for_reflog reword
562
563                 mark_action_done
564                 do_pick $sha1 "$rest"
565                 git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} \
566                         $allow_empty_message || {
567                         warn "$(eval_gettext "\
568 Could not amend commit after successfully picking \$sha1... \$rest
569 This is most likely due to an empty commit message, or the pre-commit hook
570 failed. If the pre-commit hook failed, you may need to resolve the issue before
571 you are able to reword the commit.")"
572                         exit_with_patch $sha1 1
573                 }
574                 record_in_rewritten $sha1
575                 ;;
576         edit|e)
577                 comment_for_reflog edit
578
579                 mark_action_done
580                 do_pick $sha1 "$rest"
581                 sha1_abbrev=$(git rev-parse --short $sha1)
582                 warn "$(eval_gettext "Stopped at \$sha1_abbrev... \$rest")"
583                 exit_with_patch $sha1 0
584                 ;;
585         squash|s|fixup|f)
586                 case "$command" in
587                 squash|s)
588                         squash_style=squash
589                         ;;
590                 fixup|f)
591                         squash_style=fixup
592                         ;;
593                 esac
594                 comment_for_reflog $squash_style
595
596                 test -f "$done" && has_action "$done" ||
597                         die "$(eval_gettext "Cannot '\$squash_style' without a previous commit")"
598
599                 mark_action_done
600                 update_squash_messages $squash_style $sha1
601                 author_script_content=$(get_author_ident_from_commit HEAD)
602                 echo "$author_script_content" > "$author_script"
603                 eval "$author_script_content"
604                 if ! pick_one -n $sha1
605                 then
606                         git rev-parse --verify HEAD >"$amend"
607                         die_failed_squash $sha1 "$rest"
608                 fi
609                 case "$(peek_next_command)" in
610                 squash|s|fixup|f)
611                         # This is an intermediate commit; its message will only be
612                         # used in case of trouble.  So use the long version:
613                         do_with_author output git commit --amend --no-verify -F "$squash_msg" \
614                                 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
615                                 die_failed_squash $sha1 "$rest"
616                         ;;
617                 *)
618                         # This is the final command of this squash/fixup group
619                         if test -f "$fixup_msg"
620                         then
621                                 do_with_author git commit --amend --no-verify -F "$fixup_msg" \
622                                         ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
623                                         die_failed_squash $sha1 "$rest"
624                         else
625                                 cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
626                                 rm -f "$GIT_DIR"/MERGE_MSG
627                                 do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
628                                         ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
629                                         die_failed_squash $sha1 "$rest"
630                         fi
631                         rm -f "$squash_msg" "$fixup_msg"
632                         ;;
633                 esac
634                 record_in_rewritten $sha1
635                 ;;
636         x|"exec")
637                 read -r command rest < "$todo"
638                 mark_action_done
639                 eval_gettextln "Executing: \$rest"
640                 "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
641                 status=$?
642                 # Run in subshell because require_clean_work_tree can die.
643                 dirty=f
644                 (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
645                 if test "$status" -ne 0
646                 then
647                         warn "$(eval_gettext "Execution failed: \$rest")"
648                         test "$dirty" = f ||
649                                 warn "$(gettext "and made changes to the index and/or the working tree")"
650
651                         warn "$(gettext "\
652 You can fix the problem, and then run
653
654         git rebase --continue")"
655                         warn
656                         if test $status -eq 127         # command not found
657                         then
658                                 status=1
659                         fi
660                         exit "$status"
661                 elif test "$dirty" = t
662                 then
663                         # TRANSLATORS: after these lines is a command to be issued by the user
664                         warn "$(eval_gettext "\
665 Execution succeeded: \$rest
666 but left changes to the index and/or the working tree
667 Commit or stash your changes, and then run
668
669         git rebase --continue")"
670                         warn
671                         exit 1
672                 fi
673                 ;;
674         *)
675                 warn "$(eval_gettext "Unknown command: \$command \$sha1 \$rest")"
676                 fixtodo="$(gettext "Please fix this using 'git rebase --edit-todo'.")"
677                 if git rev-parse --verify -q "$sha1" >/dev/null
678                 then
679                         die_with_patch $sha1 "$fixtodo"
680                 else
681                         die "$fixtodo"
682                 fi
683                 ;;
684         esac
685         test -s "$todo" && return
686
687         comment_for_reflog finish &&
688         newhead=$(git rev-parse HEAD) &&
689         case $head_name in
690         refs/*)
691                 message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
692                 git update-ref -m "$message" $head_name $newhead $orig_head &&
693                 git symbolic-ref \
694                   -m "$GIT_REFLOG_ACTION: returning to $head_name" \
695                   HEAD $head_name
696                 ;;
697         esac && {
698                 test ! -f "$state_dir"/verbose ||
699                         git diff-tree --stat $orig_head..HEAD
700         } &&
701         {
702                 test -s "$rewritten_list" &&
703                 git notes copy --for-rewrite=rebase < "$rewritten_list" ||
704                 true # we don't care if this copying failed
705         } &&
706         hook="$(git rev-parse --git-path hooks/post-rewrite)"
707         if test -x "$hook" && test -s "$rewritten_list"; then
708                 "$hook" rebase < "$rewritten_list"
709                 true # we don't care if this hook failed
710         fi &&
711                 warn "$(eval_gettext "Successfully rebased and updated \$head_name.")"
712
713         return 1 # not failure; just to break the do_rest loop
714 }
715
716 # can only return 0, when the infinite loop breaks
717 do_rest () {
718         while :
719         do
720                 do_next || break
721         done
722 }
723
724 expand_todo_ids() {
725         git rebase--helper --expand-ids
726 }
727
728 collapse_todo_ids() {
729         git rebase--helper --shorten-ids
730 }
731
732 # Switch to the branch in $into and notify it in the reflog
733 checkout_onto () {
734         GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
735         output git checkout $onto || die_abort "$(gettext "could not detach HEAD")"
736         git update-ref ORIG_HEAD $orig_head
737 }
738
739 get_missing_commit_check_level () {
740         check_level=$(git config --get rebase.missingCommitsCheck)
741         check_level=${check_level:-ignore}
742         # Don't be case sensitive
743         printf '%s' "$check_level" | tr 'A-Z' 'a-z'
744 }
745
746 # The whole contents of this file is run by dot-sourcing it from
747 # inside a shell function.  It used to be that "return"s we see
748 # below were not inside any function, and expected to return
749 # to the function that dot-sourced us.
750 #
751 # However, older (9.x) versions of FreeBSD /bin/sh misbehave on such a
752 # construct and continue to run the statements that follow such a "return".
753 # As a work-around, we introduce an extra layer of a function
754 # here, and immediately call it after defining it.
755 git_rebase__interactive () {
756
757 case "$action" in
758 continue)
759         if test ! -d "$rewritten"
760         then
761                 exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
762                         --continue
763         fi
764         # do we have anything to commit?
765         if git diff-index --cached --quiet HEAD --
766         then
767                 # Nothing to commit -- skip this commit
768
769                 test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
770                 rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
771                 die "$(gettext "Could not remove CHERRY_PICK_HEAD")"
772         else
773                 if ! test -f "$author_script"
774                 then
775                         gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
776                         die "$(eval_gettext "\
777 You have staged changes in your working tree.
778 If these changes are meant to be
779 squashed into the previous commit, run:
780
781   git commit --amend \$gpg_sign_opt_quoted
782
783 If they are meant to go into a new commit, run:
784
785   git commit \$gpg_sign_opt_quoted
786
787 In both cases, once you're done, continue with:
788
789   git rebase --continue
790 ")"
791                 fi
792                 . "$author_script" ||
793                         die "$(gettext "Error trying to find the author identity to amend commit")"
794                 if test -f "$amend"
795                 then
796                         current_head=$(git rev-parse --verify HEAD)
797                         test "$current_head" = $(cat "$amend") ||
798                         die "$(gettext "\
799 You have uncommitted changes in your working tree. Please commit them
800 first and then run 'git rebase --continue' again.")"
801                         do_with_author git commit --amend --no-verify -F "$msg" -e \
802                                 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
803                                 die "$(gettext "Could not commit staged changes.")"
804                 else
805                         do_with_author git commit --no-verify -F "$msg" -e \
806                                 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
807                                 die "$(gettext "Could not commit staged changes.")"
808                 fi
809         fi
810
811         if test -r "$state_dir"/stopped-sha
812         then
813                 record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
814         fi
815
816         require_clean_work_tree "rebase"
817         do_rest
818         return 0
819         ;;
820 skip)
821         git rerere clear
822
823         if test ! -d "$rewritten"
824         then
825                 exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
826                         --continue
827         fi
828         do_rest
829         return 0
830         ;;
831 edit-todo)
832         git stripspace --strip-comments <"$todo" >"$todo".new
833         mv -f "$todo".new "$todo"
834         collapse_todo_ids
835         append_todo_help
836         gettext "
837 You are editing the todo file of an ongoing interactive rebase.
838 To continue rebase after editing, run:
839     git rebase --continue
840
841 " | git stripspace --comment-lines >>"$todo"
842
843         git_sequence_editor "$todo" ||
844                 die "$(gettext "Could not execute editor")"
845         expand_todo_ids
846
847         exit
848         ;;
849 show-current-patch)
850         exec git show REBASE_HEAD --
851         ;;
852 esac
853
854 comment_for_reflog start
855
856 if test ! -z "$switch_to"
857 then
858         GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
859         output git checkout "$switch_to" -- ||
860                 die "$(eval_gettext "Could not checkout \$switch_to")"
861
862         comment_for_reflog start
863 fi
864
865 orig_head=$(git rev-parse --verify HEAD) || die "$(gettext "No HEAD?")"
866 mkdir -p "$state_dir" || die "$(eval_gettext "Could not create temporary \$state_dir")"
867 rm -f "$(git rev-parse --git-path REBASE_HEAD)"
868
869 : > "$state_dir"/interactive || die "$(gettext "Could not mark as interactive")"
870 write_basic_state
871 if test t = "$preserve_merges"
872 then
873         if test -z "$rebase_root"
874         then
875                 mkdir "$rewritten" &&
876                 for c in $(git merge-base --all $orig_head $upstream)
877                 do
878                         echo $onto > "$rewritten"/$c ||
879                                 die "$(gettext "Could not init rewritten commits")"
880                 done
881         else
882                 mkdir "$rewritten" &&
883                 echo $onto > "$rewritten"/root ||
884                         die "$(gettext "Could not init rewritten commits")"
885         fi
886         # No cherry-pick because our first pass is to determine
887         # parents to rewrite and skipping dropped commits would
888         # prematurely end our probe
889         merges_option=
890 else
891         merges_option="--no-merges --cherry-pick"
892 fi
893
894 shorthead=$(git rev-parse --short $orig_head)
895 shortonto=$(git rev-parse --short $onto)
896 if test -z "$rebase_root"
897         # this is now equivalent to ! -z "$upstream"
898 then
899         shortupstream=$(git rev-parse --short $upstream)
900         revisions=$upstream...$orig_head
901         shortrevisions=$shortupstream..$shorthead
902 else
903         revisions=$onto...$orig_head
904         shortrevisions=$shorthead
905 fi
906 if test t != "$preserve_merges"
907 then
908         git rebase--helper --make-script ${keep_empty:+--keep-empty} \
909                 $revisions ${restrict_revision+^$restrict_revision} >"$todo" ||
910         die "$(gettext "Could not generate todo list")"
911 else
912         format=$(git config --get rebase.instructionFormat)
913         # the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
914         git rev-list $merges_option --format="%m%H ${format:-%s}" \
915                 --reverse --left-right --topo-order \
916                 $revisions ${restrict_revision+^$restrict_revision} | \
917                 sed -n "s/^>//p" |
918         while read -r sha1 rest
919         do
920
921                 if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
922                 then
923                         comment_out="$comment_char "
924                 else
925                         comment_out=
926                 fi
927
928                 if test -z "$rebase_root"
929                 then
930                         preserve=t
931                         for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
932                         do
933                                 if test -f "$rewritten"/$p
934                                 then
935                                         preserve=f
936                                 fi
937                         done
938                 else
939                         preserve=f
940                 fi
941                 if test f = "$preserve"
942                 then
943                         touch "$rewritten"/$sha1
944                         printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
945                 fi
946         done
947 fi
948
949 # Watch for commits that been dropped by --cherry-pick
950 if test t = "$preserve_merges"
951 then
952         mkdir "$dropped"
953         # Save all non-cherry-picked changes
954         git rev-list $revisions --left-right --cherry-pick | \
955                 sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
956         # Now all commits and note which ones are missing in
957         # not-cherry-picks and hence being dropped
958         git rev-list $revisions |
959         while read rev
960         do
961                 if test -f "$rewritten"/$rev &&
962                    ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
963                 then
964                         # Use -f2 because if rev-list is telling us this commit is
965                         # not worthwhile, we don't want to track its multiple heads,
966                         # just the history of its first-parent for others that will
967                         # be rebasing on top of it
968                         git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
969                         sha1=$(git rev-list -1 $rev)
970                         sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
971                         rm "$rewritten"/$rev
972                 fi
973         done
974 fi
975
976 test -s "$todo" || echo noop >> "$todo"
977 test -z "$autosquash" || git rebase--helper --rearrange-squash || exit
978 test -n "$cmd" && git rebase--helper --add-exec-commands "$cmd"
979
980 todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
981 todocount=${todocount##* }
982
983 cat >>"$todo" <<EOF
984
985 $comment_char $(eval_ngettext \
986         "Rebase \$shortrevisions onto \$shortonto (\$todocount command)" \
987         "Rebase \$shortrevisions onto \$shortonto (\$todocount commands)" \
988         "$todocount")
989 EOF
990 append_todo_help
991 gettext "
992 However, if you remove everything, the rebase will be aborted.
993
994 " | git stripspace --comment-lines >>"$todo"
995
996 if test -z "$keep_empty"
997 then
998         printf '%s\n' "$comment_char $(gettext "Note that empty commits are commented out")" >>"$todo"
999 fi
1000
1001
1002 has_action "$todo" ||
1003         return 2
1004
1005 cp "$todo" "$todo".backup
1006 collapse_todo_ids
1007 git_sequence_editor "$todo" ||
1008         die_abort "$(gettext "Could not execute editor")"
1009
1010 has_action "$todo" ||
1011         return 2
1012
1013 git rebase--helper --check-todo-list || {
1014         ret=$?
1015         checkout_onto
1016         exit $ret
1017 }
1018
1019 expand_todo_ids
1020
1021 test -d "$rewritten" || test -n "$force_rebase" ||
1022 onto="$(git rebase--helper --skip-unnecessary-picks)" ||
1023 die "Could not skip unnecessary pick commands"
1024
1025 checkout_onto
1026 if test -z "$rebase_root" && test ! -d "$rewritten"
1027 then
1028         require_clean_work_tree "rebase"
1029         exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
1030                 --continue
1031 fi
1032 do_rest
1033
1034 }
1035 # ... and then we call the whole thing.
1036 git_rebase__interactive